# Summary

[Preamble](README.md)

- [Whence Parachains](whence-parachains.md)
- [Protocol Overview](protocol-overview.md)
  - [Approval Process](protocol-approval.md)
  - [Disputes Process](protocol-disputes.md)
    - [Dispute Flow](disputes-flow.md)
- [Architecture Overview](architecture.md)
  - [Messaging Overview](messaging.md)
- [Runtime Architecture](runtime/README.md)
  - [Initializer Module](runtime/initializer.md)
  - [Configuration Module](runtime/configuration.md)
  - [Disputes Module](runtime/disputes.md)
  - [Paras Module](runtime/paras.md)
  - [Scheduler Module](runtime/scheduler.md)
  - [Inclusion Module](runtime/inclusion.md)
  - [ParaInherent Module](runtime/parainherent.md)
  - [DMP Module](runtime/dmp.md)
  - [UMP Module](runtime/ump.md)
  - [HRMP Module](runtime/hrmp.md)
  - [Session Info Module](runtime/session_info.md)
- [Runtime APIs](runtime-api/README.md)
  - [Validators](runtime-api/validators.md)
  - [Validator Groups](runtime-api/validator-groups.md)
  - [Availability Cores](runtime-api/availability-cores.md)
  - [Persisted Validation Data](runtime-api/persisted-validation-data.md)
  - [Session Index](runtime-api/session-index.md)
  - [Validation Code](runtime-api/validation-code.md)
  - [Candidate Pending Availability](runtime-api/candidate-pending-availability.md)
  - [Candidate Events](runtime-api/candidate-events.md)
  - [Known Disputes](runtime-api/known-disputes.md)
- [Node Architecture](node/README.md)
  - [Subsystems and Jobs](node/subsystems-and-jobs.md)
  - [Overseer](node/overseer.md)
  - [GRANDPA Voting Rule](node/grandpa-voting-rule.md)
  - [Collator Subsystems](node/collators/README.md)
    - [Collation Generation](node/collators/collation-generation.md)
    - [Collator Protocol](node/collators/collator-protocol.md)
  - [Backing Subsystems](node/backing/README.md)
    - [Candidate Selection](node/backing/candidate-selection.md)
    - [Candidate Backing](node/backing/candidate-backing.md)
    - [Statement Distribution](node/backing/statement-distribution.md)
    - [PoV Distribution](node/backing/pov-distribution.md)
  - [Availability Subsystems](node/availability/README.md)
    - [Availability Distribution](node/availability/availability-distribution.md)
    - [Availability Recovery](node/availability/availability-recovery.md)
    - [Bitfield Distribution](node/availability/bitfield-distribution.md)
    - [Bitfield Signing](node/availability/bitfield-signing.md)
  - [Approval Subsystems](node/approval/README.md)
    - [Approval Voting](node/approval/approval-voting.md)
    - [Approval Distribution](node/approval/approval-distribution.md)
    - [Dispute Participation](node/approval/dispute-participation.md)
  - [Utility Subsystems](node/utility/README.md)
    - [Availability Store](node/utility/availability-store.md)
    - [Candidate Validation](node/utility/candidate-validation.md)
    - [Provisioner](node/utility/provisioner.md)
    - [Network Bridge](node/utility/network-bridge.md)
    - [Misbehavior Arbitration](node/utility/misbehavior-arbitration.md)
    - [Peer Set Manager](node/utility/peer-set-manager.md)
    - [Runtime API Requests](node/utility/runtime-api.md)
    - [Chain API Requests](node/utility/chain-api.md)
- [Data Structures and Types](types/README.md)
    - [Candidate](types/candidate.md)
    - [Backing](types/backing.md)
    - [Availability](types/availability.md)
    - [Overseer and Subsystem Protocol](types/overseer-protocol.md)
    - [Runtime](types/runtime.md)
    - [Chain](types/chain.md)
    - [Messages](types/messages.md)
    - [Network](types/network.md)
    - [Approvals](types/approval.md)
    - [Disputes](types/disputes.md)

[Glossary](glossary.md)
[Further Reading](further-reading.md)
